<?php
defined('BASEPATH') or die('error in test module');

class parspal extends Payment_Module 
{
		 public		$name	= 'پارسپال'; 	
		 
		 
		 //parspal merchand
		 private $pin = 10054088;
		 
		 //parspal password
		 private $pass = 1146933;
		
			/**
		*	construct method
		**/
		function __construct()
		{
			parent::__construct();
			@session_start();
			// if need nusoap class delete comment
			$this->load->helper('nusoap');
		}
		
		
			/**
		* 	method send request to bank and get authority!
		*
		* @param $price int , toman تومان
		* @param $order_id int , unique id
		* @param $callback string , callback site
		* @return object , au: authority , go: bank link payment , status: the status of connection!
		**/
		public function request($price = NULL , $order_id = NULL , $callback = NULL)
		{
			$out = new stdclass;
			$out->au = 'order-'.$order_id;
			$out->go = "";
			$out->status = true;
			
			$MerchantID = $this->pin;

			$Password = $this->pass;

			$Price = $price; //Price By Toman
		 
			$ReturnPath = $callback;

			$ResNumber = $order_id ;// Order Id In Your System
			$Description = "سفارش شماره $order_id";
			$Paymenter = '';
			$Email = '';
			$Mobile = '';

			$client = new SoapClient('http://merchant.parspal.com/WebService.asmx?wsdl');

			$res = $client->RequestPayment(array("MerchantID" => $MerchantID , "Password" =>$Password , "Price" =>$Price, "ReturnPath" =>$ReturnPath, "ResNumber" =>$ResNumber, "Description" =>$Description, "Paymenter" =>$Paymenter, "Email" =>$Email, "Mobile" =>$Mobile));

			$PayPath = $res->RequestPaymentResult->PaymentPath;
			$Status = $res->RequestPaymentResult->ResultStatus;
			
			if($Status == 'Succeed')
			{

			$_=$PayPath;
			}
			else
			{
				$_ = false;
			}
	
			$_SESSION[$out->au] = $_ ;
			
			
			return $out;
		}
		
		
			/**
		* method to check verify transaction
		*
		* @param $price int , تومان
		* @param $order_id int , unique order id 
		* @param $au string , authority code
		* @return bool true/false 
		**/
		public function verify($price = NULL ,$order_id = NULL , $au = NULL)
		{
					$MerchantID = $this->pin;

			$Password = $this->pass;

			$Price = $price; //Price By Toman
		 
			
			if(isset($_POST['status']) && $_POST['status'] == 100){
				$Status = $_POST['status'];

				$Refnumber = $_POST['refnumber'];

				$Resnumber = $_POST['resnumber'];
		//Your Order ID

				$client = new SoapClient('http://merchant.parspal.com/WebService.asmx?wsdl');

				$res = $client->VerifyPayment(array("MerchantID" => $MerchantID , "Password" =>$Password , "Price" =>$Price,"RefNum" =>$Refnumber ));
			


				
				$Status = $res->verifyPaymentResult->ResultStatus;
				$PayPrice = $res->verifyPaymentResult->PayementedPrice;
				if($Status == 'success')// Your Peyment Code Only This Event
				{
					return true;
				}else{
					return false;
				}
			}
			else
			{
				return false;
			}

			return false;
		}
		
		
		
		function go($id)
		{
			//die($id);
			$_ = $_SESSION[$id];
			if($_!==false)
			 header('Location: '.strip_tags($_));
			 else
			 _show_error('ارتباط برقرار نشد');
			 die('...');
		}
}

// Location : application/payment_modules/test.php
